<?php
//Script creado por Carlos www.meteoviso.es
// Versión 030524 23:00  Its ok

// Configuración de errores
error_reporting(E_ALL);
ini_set('display_errors', 1);

 
// Rutas de los archivos
$realtime = "/var/www/html/realtime.txt";
//$realtime = "/var/www/html/script/realtime/realtimemod.txt"; // Prueba
$lastrainfile = "/var/www/html/script/lastraintotal.txt";
// Lee el contenido del archivo para extraer la fecha
$capturado = file_get_contents($realtime);

// Busca el patrón de fecha y hora en el contenido
$patron = '/(\d{2}\/\d{2}\/\d{2} \d{2}:\d{2}:\d{2})/';
if (preg_match($patron, $capturado, $coincidencias)) {
$fechaActual = $coincidencias[1];
// Agrega "20" al año en el formato de fecha para que el año siempre sea de 4 dígitos
$fechaActual = preg_replace('/\/(\d{2}) /', '/20$1 ', $fechaActual);
}

$fechaActualreal = date('H:i:s d/m/Y');
 
 
echo 'Fecha actual capturada del fichero realtime: ' . $fechaActual . "<br>";
$fechaDateTime = DateTime::createFromFormat('d/m/Y H:i:s', $fechaActual);
$horaActual = $fechaDateTime->format('H:i:s');
$hoy = $fechaDateTime->format('d/m/Y');
$ayer = $fechaDateTime->modify('-1 day')->format('d/m/Y');
$diahoy = substr($hoy, 0, 2); // Obtiene los primeros dos caracteres (el día) de la cadena $hoy
$diaayer = substr($ayer, 0, 2); // Obtiene los primeros dos caracteres (el día) de la cadena $ayer

echo 'Fecha y hora real: ' . $fechaActualreal . "<br>";
echo 'Fecha de hoy:  ' . $hoy .   '  Dia de hoy: ' . $diahoy . "<br>";
echo 'Fecha de ayer: ' . $ayer . '  Dia de ayer: ' . $diaayer . "<br>";



if (strpos($realtime, 'realtime.txt') !== false) {
echo '<span style="color: green; font-size: 18px;"><strong>Texto para realtime.txt</strong></span>';
} elseif (strpos($realtime, 'realtimemod.txt') !== false) {
echo '<span style="color: blue; font-size: 18px;"><strong>Texto para realtimemod.txt</strong></span>';
} else {
echo '<span style="color: green; font-size: 18px;"><strong>Texto para realtime.txt</strong></span>';
}
 

// Archivo de caché para almacenar el estado de la lluvia
$cachefile = "/var/www/html/script/lastrain.txt";

// Lee el archivo de caché y extrae los valores actuales
$cachefilecontenido = file_get_contents($cachefile);
$lastrainfilecontenido = file_get_contents($lastrainfile);
$lineas = explode("\n", $cachefilecontenido);

// Lee valores actuales
$lluvia = explode(" ", $capturado);
$intensidad = ($lluvia[8]);
$lluviahoy = ($lluvia[9]); 
$ultimoepisodio = "0.0";
$lluviaayer= ($lluvia[21]);  
$lluviahoy_inicial = $lineas[1];
$lluviahoy_inicial_antes = $lineas[1];
$contadorlluvia0 ="0";
$contadorlluvia1 ="0";
$contadorlluvia2 ="0";
$contadorlluvia3 ="0";
 
 
//Valor almacenado en cada array
//hoy            0
//hoyinicial     1
//ayer           2
//episodio       3
//contador0      4
//contador1      5
//contador2      6
//contador3      7
 
  
 
//$lineas[x] = $variable; Asigna el valor a la variable para despues escribirlo en la linea del fichero cache ESCRIBE
//$variable = $lineas[x]; Lee de fichero cache la linea y la asigna a variable LEE
 
// Guarda los valores en el archivo de caché de lluviahoy y lluviaayer
  
$lineas[0] = $lluviahoy; //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$lineas[2] = $lluviaayer; //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$new_cachefilecontenido0 = implode("\n", $lineas);
if ($cachefilecontenido !== $new_cachefilecontenido0) {	  //TEST											   
file_put_contents($cachefile, $new_cachefilecontenido0);
}	
	

$contadorlluvia1 = $lineas[5];// Lee de fichero cache la linea y la asigna a variable
if ($intensidad > 0 &&  $contadorlluvia1 == 0) {
echo "<br>"." Ejecutando if i>0 c1=1      1";
// Incrementa el contador de lluvia
$contadorlluvia1 = 1;
// Guarda los valores en el archivo de caché  
$lineas[5] = $contadorlluvia1; //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$new_cachefilecontenido1 = implode("\n", $lineas);
if ($cachefilecontenido !== $new_cachefilecontenido1) {	  //TEST	
file_put_contents($cachefile, $new_cachefilecontenido1);
}
}	 
////Actualizar valor solo de  lluviahoy y ayer
$lineas[2] = $lluviaayer;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
// Guarda los valores en el archivo de caché
$new_cachefilecontenido = implode("\n", $lineas);
if ($cachefilecontenido !== $new_cachefilecontenido) {	  //TEST	
file_put_contents($cachefile, $new_cachefilecontenido);
}
 
 
 
$diahoyleido = $lineas[8];
$cambiodia= 0;
$cambiodia = $lineas[9];// Lee de fichero cache la linea y la asigna a variable
 // Determinar si hay cambio de día
if ($diahoy != $diahoyleido) {
	echo "<br>";
    echo '<span style="color: orange;">Ejecutando if cambio dia   0</span>'."<br>";
	$lineas[8] = $diahoy ;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
    // Guardar cambios en el archivo de caché
	$cambiodia= 1;
	$lineas[9] = $cambiodia ;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
    $new_cachefilecontenido = implode("\n", $lineas);
	if ($cachefilecontenido !== $new_cachefilecontenido) {	  //TEST	
    file_put_contents($cachefile, $new_cachefilecontenido);
    }
    // Recalcular el episodio de lluvia si es necesario
    // Aquí puedes agregar la lógica para calcular el episodio de lluvia
}
echo "<br>";  
//echo "llh" .$lluviahoy. " dh ". $diahoy ." dhl " . $diahoyleido; 

//////////////////////
echo "<br>";  
$lluviahoy_inicial_actualizada = true;
$ultimoepisodio = isset($lineas[3]) ? (float)$lineas[3] : 0.0;
$contadorlluvia2 = $lineas[6];// Lee de fichero cache la linea y la asigna a variable

if ($lluviahoy > 0.0 && $intensidad == 0 && $contadorlluvia2 == 0 && $cambiodia == 0) {
echo '<span style="color: red;">Ejecutando if Guardando episodio     2</span>';
echo "<br>";
$contadorlluvia2 = 1; // Lee de fichero cache la linea y la asigna a variable
$contadorlluvia3 = 0; // Lee de fichero cache la linea y la asigna a variable //Restaura contador a 0 
$lineas[7] = $contadorlluvia3;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$lineas[6] = $contadorlluvia2;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
 

$ultimoepisodio = number_format($lluviahoy - $lluviahoy_inicial, 1);

 
	 
 if ($lluviahoy_inicial_actualizada) { 
 echo '<span style="color: orange;">Ejecutando if Actualizando lluviahoy_inicial    3</span>'."<br>";
 $lluviahoy_inicial = $lineas[1];// Lee de fichero cache la linea y la asigna a variable; 
 $lluviahoy_inicial = $lineas[0];// Lee de fichero cache la linea y la asigna a variable
 $lineas[1] = $lluviahoy_inicial;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
 $lluviahoy_inicial_actualizada = false;
 $lluviahoy_inicial = $lluviahoy_inicial ?? "0.0"; 
 }
 	   
$lineas[3] = $ultimoepisodio;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$new_cachefilecontenido3 = implode("\n", $lineas);
if ($cachefilecontenido !== $new_cachefilecontenido3) {	  //TEST	
file_put_contents($cachefile, $new_cachefilecontenido3);
}
}  





if  (($lluviahoy > 0.0 || $lluviaayer > 0.0) && $intensidad == 0 && $contadorlluvia2 == 0 && $cambiodia == 1) {
echo '<span style="color: red;">Ejecutando if Guardando episodio con cambiodia y +lluviaayer   2</span>';
echo "<br>";
$contadorlluvia2 = 1; // Lee de fichero cache la linea y la asigna a variable
$contadorlluvia3 = 0; // Lee de fichero cache la linea y la asigna a variable //Restaura contador a 0 
$lineas[7] = $contadorlluvia3;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$lineas[6] = $contadorlluvia2;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$ultimoepisodio = number_format($lluviaayer + $lluviahoy - $lluviahoy_inicial, 1);	   

	 
 if ($lluviahoy_inicial_actualizada) { 
 echo '<span style="color: orange;">Ejecutando if Actualizando lluviahoy_inicial con cambio de dia   3</span>'."<br>";
 $lluviahoy_inicial = $lineas[1];// Lee de fichero cache la linea y la asigna a variable; 
 $lluviahoy_inicial = $lineas[0];// Lee de fichero cache la linea y la asigna a variable
 $lineas[1] = $lluviahoy_inicial;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
 $cambiodia= 0;
 $lineas[9] = $cambiodia ;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
 $lluviahoy_inicial_actualizada = false;
 $lluviahoy_inicial = $lluviahoy_inicial ?? "0.0"; 
 }

 
$lineas[3] = $ultimoepisodio;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$new_cachefilecontenido3 = implode("\n", $lineas);
if ($cachefilecontenido !== $new_cachefilecontenido3) {	  //TEST	
file_put_contents($cachefile, $new_cachefilecontenido3);
}
}
	
	
 
echo "<br>";
$contadorlluvia3 = $lineas[7]; // Lee de fichero cache la linea y la asigna a variable
$contadorlluvia2 = $lineas[6]; // Lee de fichero cache la linea y la asigna a variable
if ($lluviahoy > 0.0 && $intensidad > 0.0 &&  $contadorlluvia2 == 1 && $contadorlluvia3 == 0) {
$contadorlluvia1 = 0; // Lee de fichero cache la linea y la asigna a variable //Restaura contador a 0
$contadorlluvia2 = 0; // Lee de fichero cache la linea y la asigna a variable //Restaura contador a 0
$contadorlluvia3 = 1; // Lee de fichero cache la linea y la asigna a variable
$lineas[5] = $contadorlluvia1;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$lineas[6] = $contadorlluvia2;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$lineas[7] = $contadorlluvia3;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
echo '<span style="color: yellow;">Ejecutando if contadorlluviax   4</span>'; 
$new_cachefilecontenido5 = implode("\n", $lineas);
// Escribe el nuevo contenido en el archivo de caché
if ($cachefilecontenido !== $new_cachefilecontenido5) {	  //TEST	
file_put_contents($cachefile, $new_cachefilecontenido5);
}
echo "<br>";
}
//Guardamos variable en el fichero	
$ultimoepisodio = number_format($ultimoepisodio, 1);
if ($lastrainfilecontenido !== $ultimoepisodio) {	  //TEST	
file_put_contents($lastrainfile, $ultimoepisodio);
}
// Determinar si la intensidad es mayor que 0
if ($intensidad > 0) {
// Si la intensidad es mayor que 0, aplicar estilo
echo '<a style="font-weight: bold; color: red;">Intensidad de lluvia: ' . $intensidad . '</a>'."<br>";
} else {
// Si la intensidad es 0 o menor, no aplicar estilo adicional
echo 'Intensidad de lluvia: ' . $intensidad . ''."<br>"."<br>";
}


$lineas[3] =  number_format($ultimoepisodio, 1); //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
echo "Valor actual de lluvia hoy: " . $lluviahoy . "<br>";
echo "Valor de lluvia hoy inicial antes: " . $lluviahoy_inicial_antes. "<br>";
echo "Valor lluvia hoy inicial: " . $lluviahoy_inicial . "<br>";
echo "Valor guardado de lluvia ayer: " . $lluviaayer . "<br>";
echo "Último episodio de lluvia: " . number_format($ultimoepisodio, 1). "<br>";
echo "Contador0: " . $contadorlluvia0 . "<br>"; 
echo "Contador1: " . $contadorlluvia1 . "<br>";
echo "Contador2: " . $contadorlluvia2 . "<br>";
echo "Contador3: " . $contadorlluvia3 . "<br>";
echo "Diahoy: " . $diahoy. "<br>"; 
echo "Cambiodia: " . $cambiodia. "<br>"; 
// Mostrar el contenido  
echo "Contenido de cache:<br>";
foreach ($lineas as $line) {
echo $line . "<br>";
}
 
echo nl2br("//hoy            0\n" .
           "//hoyinicial     1\n" .
		   "//ayer           2\n" .
           "//episodio       3\n" .
           "//contador0      4\n" .
           "//contador1      5\n" .
           "//contador2      6\n" .
		   "//contador3      7\n" .
		   "//diahoy         8\n" .
		   "//cambiodia      9\n");
	

//Resetear cambio de dia a 0
if ($cambiodia == 1 && $intensidad == 0) {	
 $lineas[9] = 0;//Asigna el valor a la variable para despues escribirlo en la linea del fichero cache	
echo "Reseteando cambio de dia tras dejar de llover"."<br>"; 
}	   

// Verificar si el archivo existe y ha sido modificado en las últimas 24 horas, si no se ha modificado en 24 lo resetea
if (file_exists($lastrainfile) && (time() - filemtime($lastrainfile) > 24 * 3600)) {
    // El archivo no ha sido modificado en las últimas 24 horas, así que ponemos todo a 0
$lineas[0] = "0.0"; //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$lineas[1] = "0.0"; //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache	
$lineas[2] = "0.0"; //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$lineas[3] = "0.0"; //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$lineas[4] = "0"; //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$lineas[5] = "0"; //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$lineas[6] = "0"; //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$lineas[7] = "0"; //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
//$lineas[9] = "0"; //Asigna el valor a la variable para despues escribirlo en la linea del fichero cache
$new_cachefilecontenido5 = implode("\n", $lineas);
if ($cachefilecontenido !== $new_cachefilecontenido5) {	  //TEST	
file_put_contents($cachefile, $new_cachefilecontenido5);
}
}

?>
